data "local_file" "gitlab_sh" {
  filename = "${path.module}/install.sh"
}

resource "local_file" "ssh_private_key" {
  content         = var.ssh_private_key
  filename        = ".ssh/${var.instance_name}"
  file_permission = "0600"
}

resource "null_resource" "gitlab_docker" {
  triggers = {
    gitlab_sh = data.local_file.gitlab_sh.content,
    instance  = var.public_ip,
    user      = var.ssh_username
    image     = var.gitlab_image
    filefound = fileexists(".ssh/opstrace-config.json") ? "1" : uuid()
  }

  connection {
    type        = "ssh"
    user        = var.ssh_username
    host        = var.public_ip
    timeout     = "500s"
    private_key = var.ssh_private_key
  }

  provisioner "file" {
    source      = "${path.module}/install.sh"
    destination = "/tmp/install.sh"
  }

  # Use the local-exec provisioner instead of remote-exec because we have more control over how
  # the script is called.
  # Constantly running into permission denied errors when executing the inline commands using remote-exec.advanced_machine_features {
  # Tried all suggested fixes in https://github.com/hashicorp/terraform/issues/5397 to no avail.
  # The fix is to specifically call the interpreter /bin/bash /tmp/install.sh
  provisioner "local-exec" {
    command = "ssh -o StrictHostKeyChecking=no -i .ssh/${var.instance_name} ${var.ssh_username}@${var.public_ip} '/bin/bash /tmp/install.sh ${var.registry_username} ${var.registry_auth_token} ${var.domain} ${var.gitlab_image} ${var.gob_domain}'"
  }
  # Copy remote config file > local, so we can output the contents and use to configure opstrace
  provisioner "local-exec" {
    command = "scp -o StrictHostKeyChecking=no -i .ssh/${var.instance_name} ${var.ssh_username}@${var.public_ip}:/tmp/opstrace-config.json .ssh/opstrace-config.json"
  }

}

# This file is generated by null_resource.gitlab_docker so we use
# data to read it after null_resource.gitlab_docker has executed.
# We primarily use the below data source for return terraform outputs
# which allow other modules to depend on the content contained in this file
# easily with for example: module.gitlab.admin_token
data "local_file" "opstrace_config" {
  filename = ".ssh/opstrace-config.json"

  depends_on = [
    null_resource.gitlab_docker
  ]
}